/*
 * File : dlDisconnected.h
 *
 * Description : This file contains declaration for class dlDisconnected.
 */

#ifndef _dlDisconnected_h_
#define _dlDisconnected_h_


#include "dlStateMachine.h"

/*
 * Class : dlDisconnected
 *
 * Description : This class inherits from dlStateMachine and provides
 *	the behaviour for the dlDisconnected state of the data-link layer.
 * 	It redefines the appropriate base class methods to handle events
 *	like DL_ConnectReq, DL_DisconnectReq, IFRAME, SABM, DISC, RR,
 *	RNR & REJ.
 */

class dlDisconnected : public dlStateMachine {

 public:
	dlDisconnected(dllayer *dl); 
	virtual ~dlDisconnected() {}
	dlStateMachine *DlConnectReq(int &errorCode); 
	dlStateMachine *DlDisconnectReq(int &errorCode)
		{ errorCode = codeSuccessful; return this; }

	dlStateMachine *HandleIframe(int &errorCode); 
	dlStateMachine *HandleSabm(int &errorCode); 
	dlStateMachine *HandleDisc(int &errorCode); 
	dlStateMachine *HandleRr(int &errorCode); 
	dlStateMachine *HandleRnr(int &errorCode); 
	dlStateMachine *HandleRej(int &errorCode); 
	virtual void PrintState(); 
};


#endif
